--- linux-4.11/drivers/media/usb/cx231xx/cx231xx-dvb.c.0140~	2017-05-01 04:47:48.000000000 +0200
+++ linux-4.11/drivers/media/usb/cx231xx/cx231xx-dvb.c	2017-06-30 13:33:26.636749934 +0200
@@ -34,8 +34,11 @@
 #include "lgdt3305.h"
 #include "si2165.h"
 #include "si2168.h"
+#include "si2168b.h"
+#include "silg.h"
 #include "mb86a20s.h"
 #include "si2157.h"
+#include "silabs_tercab.h"
 #include "lgdt3306a.h"
 
 MODULE_DESCRIPTION("driver for cx231xx based DVB cards");
@@ -129,6 +132,38 @@ static struct lgdt3305_config hcw_lgdt33
 	.vsb_if_khz         = 3250,
 };
 
+static struct lgdt3306a_config hcw_lgdt3306a_config = {
+	/* LG3306A demodulator configuration */
+	.i2c_addr           = 0xB2 >> 1,
+
+	/* user defined IF frequency in KHz */
+	.qam_if_khz         = HVR19x5_QAM_IF, //needs to match tuner
+	.vsb_if_khz         = HVR19x5_VSB_IF, //needs to match tuner
+
+	/* disable i2c repeater - 0:repeater enabled 1:repeater disabled */
+	.deny_i2c_rptr      = 1,
+
+	/* spectral inversion - 0:disabled 1:enabled */
+	.spectral_inversion = 1,
+
+	.mpeg_mode          = LGDT3306A_MPEG_SERIAL,
+	.tpclk_edge         = LGDT3306A_TPCLK_RISING_EDGE,
+	.tpvalid_polarity   = LGDT3306A_TP_VALID_HIGH,
+
+	.xtalMHz            = 25, //demod clock freq in MHz; 24 or 25 supported
+};
+
+static struct silabs_tercab_config hauppauge_si2157_config = {
+	.tuner_address           = 0xC0 >> 1,      /* address of the tuner for ATSC/DVB-T */
+	.qam_if_khz              = HVR19x5_QAM_IF, /* needs to match demods qam if */
+	.vsb_if_khz              = HVR19x5_VSB_IF, /* needs to match demods vsb if */
+	.tuner_clock_control     = 1, /* 0:always off 1:always on 2:clock managed */
+	.tuner_agc_control       = 1,
+	.fef_mode                = 0, /* fef mode slow normal agc */
+	.crystal_trim_xo_cap     = 2,
+	.indirect_i2c_connection = 1, /* Si2157 connected directly */
+};
+
 static struct tda18271_std_map hauppauge_tda18271_std_map = {
 	.atsc_6   = { .if_freq = 3250, .agc_mode = 3, .std = 4,
 		      .if_lvl = 1, .rfagc_top = 0x58, },
@@ -164,6 +199,50 @@ static struct lgdt3306a_config hauppauge
 	.xtalMHz            = 25,
 };
 
+static const struct si2168b_config hauppauge_935C_si2168b_config = {
+	.demod_address           = 0xC8 >> 1,
+	.min_delay_ms            = 85,
+	.ts_bus_mode             = 1, /*1-serial, 2-parallel.*/
+	.ts_clock_mode           = 1, /*0-auto_fixed, 1-auto_adapt, 2-manual.*/
+	.clk_gapped_en           = 1, /*0-disabled, 1-enabled.*/
+	.ts_par_clk_invert       = 1, /*0-not-invert, 1-invert*/
+	.ts_par_clk_shift        = 0,
+	.fef_mode                = 0, /* needs to match tuner */
+	.fef_pin                 = 3,
+	.fef_level               = 0,
+	.indirect_i2c_connection = 1, /*Si2177 connected directly*/
+	.start_ctrl              = NULL,
+};
+
+static struct silg_config hauppauge_975_silg_config = {
+	/* Si2168B demodulator configuration */
+	.si_demod_enable         = !0,
+	.si_i2c_addr             = 0xC8 >> 1,
+	.min_delay_ms            = 85,
+	.ts_bus_mode             = 1, /*1-serial, 2-parallel.*/
+	.ts_clock_mode           = 1, /*0-auto_fixed, 1-auto_adapt, 2-manual.*/
+	.clk_gapped_en           = 1, /*0-disabled, 1-enabled.*/
+	.ts_par_clk_invert       = 1, /*0-not-invert, 1-invert*/
+	.ts_par_clk_shift        = 0,
+	.fef_mode                = 0, /* needs to match tuner */
+	.fef_pin                 = 3,
+	.fef_level               = 0,
+	.indirect_i2c_connection = 1, /*Si2177 connected directly*/
+	.start_ctrl              = NULL,
+
+	/* LG3306A demodulator configuration */
+	.lg_demod_enable         = !0,
+	.lg_i2c_addr             = 0xB2 >> 1,
+	.mpeg_mode               = LGDT3306A_MPEG_SERIAL,
+	.tpclk_edge              = LGDT3306A_TPCLK_RISING_EDGE,
+	.tpvalid_polarity        = LGDT3306A_TP_VALID_HIGH,
+	.deny_i2c_rptr           = 1,
+	.spectral_inversion      = 1,
+	.qam_if_khz              = HVR19x5_QAM_IF, /* needs to match tuner */
+	.vsb_if_khz              = HVR19x5_VSB_IF, /* needs to match tuner */
+	.xtalMHz                 = 25,
+};
+
 static inline void print_err_status(struct cx231xx *dev, int packet, int status)
 {
 	char *errmsg = "Unknown";
@@ -266,7 +345,7 @@ static int start_streaming(struct cx231x
 
 	if (dev->USE_ISO) {
 		dev_dbg(dev->dev, "DVB transfer mode is ISO.\n");
-		cx231xx_set_alt_setting(dev, INDEX_TS1, 4);
+		cx231xx_set_alt_setting(dev, INDEX_TS1, 5);
 		rc = cx231xx_set_mode(dev, CX231XX_DIGITAL_MODE);
 		if (rc < 0)
 			return rc;
@@ -924,6 +1003,87 @@ static int dvb_init(struct cx231xx *dev)
 		dev->dvb->i2c_client_tuner = client;
 		break;
 	}
+	case CX231XX_BOARD_HAUPPAUGE_EXETER_955Q:
+
+		dev_info(dev->dev,
+			"%s: looking for tuner / demod on i2c bus: %d\n",
+			__func__, i2c_adapter_id(tuner_i2c));
+
+		dev->dvb->frontend = dvb_attach(lgdt3306a_attach,
+			&hcw_lgdt3306a_config,
+			tuner_i2c);
+
+		if (dev->dvb->frontend == NULL) {
+			dev_info(dev->dev,
+			       ": Failed to attach LG3306A front end\n");
+			result = -EINVAL;
+			goto out_free;
+		}
+
+		dev->dvb->frontend->ops.i2c_gate_ctrl = NULL;
+
+		/* define general-purpose callback pointer */
+		dvb->frontend->callback = cx231xx_tuner_callback;
+
+		dvb_attach(silabs_tercab_attach, dev->dvb->frontend,
+			tuner_i2c,
+			&hauppauge_si2157_config);
+		break;
+
+	case CX231XX_BOARD_HAUPPAUGE_935C:
+
+		dev_info(dev->dev,
+			"%s: looking for tuner / demod on i2c bus: %d\n",
+			__func__, i2c_adapter_id(tuner_i2c));
+
+		dev->dvb->frontend = dvb_attach(si2168b_attach,
+			&hauppauge_935C_si2168b_config,
+			tuner_i2c);
+
+		if (dev->dvb->frontend == NULL) {
+			dev_info(dev->dev,
+			       ": Failed to attach Si2168B front end\n");
+			result = -EINVAL;
+			goto out_free;
+		}
+
+		dev->dvb->frontend->ops.i2c_gate_ctrl = NULL;
+
+		/* define general-purpose callback pointer */
+		dvb->frontend->callback = cx231xx_tuner_callback;
+
+		dvb_attach(silabs_tercab_attach, dev->dvb->frontend,
+			tuner_i2c,
+			&hauppauge_si2157_config);
+		break;
+
+	case CX231XX_BOARD_HAUPPAUGE_975:
+
+		dev_info(dev->dev,
+			"%s: looking for tuner / demod on i2c bus: %d\n",
+			__func__, i2c_adapter_id(tuner_i2c));
+
+		dev->dvb->frontend = dvb_attach(silg_attach,
+			&hauppauge_975_silg_config,
+			tuner_i2c);
+
+		if (dev->dvb->frontend == NULL) {
+			dev_info(dev->dev,
+			       ": Failed to attach SILG front end\n");
+			result = -EINVAL;
+			goto out_free;
+		}
+
+		dev->dvb->frontend->ops.i2c_gate_ctrl = NULL;
+
+		/* define general-purpose callback pointer */
+		dvb->frontend->callback = cx231xx_tuner_callback;
+
+		dvb_attach(silabs_tercab_attach, dev->dvb->frontend,
+			tuner_i2c,
+			&hauppauge_si2157_config);
+		break;
+
 	case CX231XX_BOARD_PV_PLAYTV_USB_HYBRID:
 	case CX231XX_BOARD_KWORLD_UB430_USB_HYBRID:
 
@@ -1054,12 +1214,20 @@ out_free:
 
 static int dvb_fini(struct cx231xx *dev)
 {
+	struct i2c_client *client;
+
 	if (!dev->board.has_dvb) {
 		/* This device does not support the extension */
 		return 0;
 	}
 
 	if (dev->dvb) {
+		client = dev->dvb->i2c_client_tuner;
+		/* remove I2C tuner */
+		if (client) {
+			module_put(client->dev.driver->owner);
+			i2c_unregister_device(client);
+		}
 		unregister_dvb(dev->dvb);
 		dev->dvb = NULL;
 	}
--- linux-4.11/drivers/media/usb/cx231xx/cx231xx.h.0140~	2017-05-01 04:47:48.000000000 +0200
+++ linux-4.11/drivers/media/usb/cx231xx/cx231xx.h	2017-06-30 13:33:26.636749934 +0200
@@ -79,6 +79,9 @@
 #define CX231XX_BOARD_HAUPPAUGE_955Q 21
 #define CX231XX_BOARD_TERRATEC_GRABBY 22
 #define CX231XX_BOARD_EVROMEDIA_FULL_HYBRID_FULLHD 23
+#define CX231XX_BOARD_HAUPPAUGE_EXETER_955Q 24
+#define CX231XX_BOARD_HAUPPAUGE_935C 25
+#define CX231XX_BOARD_HAUPPAUGE_975 26
 
 /* Limits minimum and default number of buffers */
 #define CX231XX_MIN_BUF                 4
--- linux-4.11/drivers/media/usb/cx231xx/cx231xx-video.c.0140~	2017-05-01 04:47:48.000000000 +0200
+++ linux-4.11/drivers/media/usb/cx231xx/cx231xx-video.c	2017-06-30 13:33:26.636749934 +0200
@@ -1094,6 +1094,18 @@ static int vidioc_s_std(struct file *fil
 	/* do mode control overrides */
 	cx231xx_do_mode_ctrl_overrides(dev);
 
+	dev_info(dev->dev,
+			"%s(): calling cx231xx_dif_set_standards(): norm=0x%08llX\n",
+			__func__, dev->norm);
+	rc = cx231xx_dif_set_standard(dev, dev->norm);
+	if (rc < 0) {
+		dev_err(dev->dev,
+				"%s: cx231xx_dif set to By pass"
+				" mode- errCode [%d]!\n",
+				__func__, rc);
+		return -EIO;
+	}
+
 	return 0;
 }
 
@@ -1317,7 +1329,7 @@ int cx231xx_s_frequency(struct file *fil
 	/* set post channel change settings in DIF first */
 	rc = cx231xx_tuner_post_channel_change(dev);
 
-	if (dev->tuner_type == TUNER_NXP_TDA18271) {
+	if (dev->tuner_type == TUNER_NXP_TDA18271 || dev->tuner_type == TUNER_SILABS_TERCAB) {
 		if (dev->norm & (V4L2_STD_MN | V4L2_STD_NTSC_443))
 			if_frequency = 5400000;  /*5.4MHz	*/
 		else if (dev->norm & V4L2_STD_B)
--- linux-4.11/drivers/media/usb/cx231xx/Kconfig.0140~	2017-05-01 04:47:48.000000000 +0200
+++ linux-4.11/drivers/media/usb/cx231xx/Kconfig	2017-06-30 13:33:26.636749934 +0200
@@ -45,12 +45,15 @@ config VIDEO_CX231XX_DVB
 	select VIDEOBUF_DVB
 	select MEDIA_TUNER_XC5000 if MEDIA_SUBDRV_AUTOSELECT
 	select MEDIA_TUNER_TDA18271 if MEDIA_SUBDRV_AUTOSELECT
+	select MEDIA_TUNER_SILABS_TERCAB if MEDIA_SUBDRV_AUTOSELECT
 	select DVB_MB86A20S if MEDIA_SUBDRV_AUTOSELECT
 	select DVB_LGDT3305 if MEDIA_SUBDRV_AUTOSELECT
 	select DVB_LGDT3306A if MEDIA_SUBDRV_AUTOSELECT
 	select DVB_TDA18271C2DD if MEDIA_SUBDRV_AUTOSELECT
 	select DVB_SI2165 if MEDIA_SUBDRV_AUTOSELECT
 	select DVB_SI2168 if MEDIA_SUBDRV_AUTOSELECT
+	select DVB_SI2168B if MEDIA_SUBDRV_AUTOSELECT
+	select DVB_SILG if MEDIA_SUBDRV_AUTOSELECT
 	select MEDIA_TUNER_SI2157 if MEDIA_SUBDRV_AUTOSELECT
 
 	---help---
--- linux-4.11/drivers/media/usb/pvrusb2/Kconfig.0140~	2017-05-01 04:47:48.000000000 +0200
+++ linux-4.11/drivers/media/usb/pvrusb2/Kconfig	2017-06-30 13:33:26.636749934 +0200
@@ -39,10 +39,13 @@ config VIDEO_PVRUSB2_DVB
 	select DVB_LGDT330X if MEDIA_SUBDRV_AUTOSELECT
 	select DVB_S5H1409 if MEDIA_SUBDRV_AUTOSELECT
 	select DVB_S5H1411 if MEDIA_SUBDRV_AUTOSELECT
+	select DVB_SI2168B if MEDIA_SUBDRV_AUTOSELECT
+	select DVB_SILG if MEDIA_SUBDRV_AUTOSELECT
 	select DVB_TDA10048 if MEDIA_SUBDRV_AUTOSELECT
 	select MEDIA_TUNER_TDA18271 if MEDIA_SUBDRV_AUTOSELECT
 	select MEDIA_TUNER_SIMPLE if MEDIA_SUBDRV_AUTOSELECT
 	select MEDIA_TUNER_TDA8290 if MEDIA_SUBDRV_AUTOSELECT
+	select MEDIA_TUNER_SILABS_TERCAB if MEDIA_SUBDRV_AUTOSELECT
 	---help---
 
 	  This option enables a DVB interface for the pvrusb2 driver.
--- linux-4.11/drivers/media/usb/pvrusb2/pvrusb2-cx2584x-v4l.c.0140~	2017-05-01 04:47:48.000000000 +0200
+++ linux-4.11/drivers/media/usb/pvrusb2/pvrusb2-cx2584x-v4l.c	2017-06-30 13:33:26.636749934 +0200
@@ -112,10 +112,35 @@ static const struct routing_scheme routi
 	.cnt = ARRAY_SIZE(routing_schemeav400),
 };
 
+static const struct routing_scheme_item routing_scheme160xxx[] = {
+	[PVR2_CVAL_INPUT_TV] = {
+		.vid = CX25840_COMPOSITE7,
+		.aud = CX25840_AUDIO8,
+	},
+	[PVR2_CVAL_INPUT_RADIO] = {
+		.vid = CX25840_COMPOSITE4,
+		.aud = CX25840_AUDIO6,
+	},
+	[PVR2_CVAL_INPUT_COMPOSITE] = {
+		.vid = CX25840_COMPOSITE3,
+		.aud = CX25840_AUDIO_SERIAL,
+	},
+	[PVR2_CVAL_INPUT_SVIDEO] = {
+		.vid = CX25840_SVIDEO1,
+		.aud = CX25840_AUDIO_SERIAL,
+	},
+};
+
+static const struct routing_scheme routing_def160xxx = {
+	.def = routing_scheme160xxx,
+	.cnt = ARRAY_SIZE(routing_scheme160xxx),
+};
+
 static const struct routing_scheme *routing_schemes[] = {
 	[PVR2_ROUTING_SCHEME_HAUPPAUGE] = &routing_def0,
 	[PVR2_ROUTING_SCHEME_GOTVIEW] = &routing_defgv,
 	[PVR2_ROUTING_SCHEME_AV400] = &routing_defav400,
+	[PVR2_ROUTING_SCHEME_HAUP160XXX] = &routing_def160xxx,
 };
 
 void pvr2_cx25840_subdev_update(struct pvr2_hdw *hdw, struct v4l2_subdev *sd)
--- linux-4.11/drivers/media/usb/pvrusb2/pvrusb2-devattr.c.0140~	2017-05-01 04:47:48.000000000 +0200
+++ linux-4.11/drivers/media/usb/pvrusb2/pvrusb2-devattr.c	2017-06-30 13:33:26.636749934 +0200
@@ -31,15 +31,18 @@ pvr2_device_desc structures.
 #ifdef CONFIG_VIDEO_PVRUSB2_DVB
 #include "pvrusb2-hdw-internal.h"
 #include "lgdt330x.h"
+#include "lgdt3306a.h"
 #include "s5h1409.h"
 #include "s5h1411.h"
 #include "tda10048.h"
 #include "tda18271.h"
 #include "tda8290.h"
 #include "tuner-simple.h"
+#include "silabs_tercab.h"
+#include "si2168b.h"
+#include "silg.h"
 #endif
 
-
 /*------------------------------------------------------------------------*/
 /* Hauppauge PVR-USB2 Model 29xxx */
 
@@ -474,6 +477,143 @@ static const struct pvr2_dvb_props pvr2_
 };
 #endif
 
+/*------------------------------------------------------------------------*/
+/* Hauppauge PVR-USB2 Models 160xxx */
+
+#ifdef CONFIG_VIDEO_PVRUSB2_DVB
+#define HVR19x5_QAM_IF 4000
+#define HVR19x5_VSB_IF 3250
+
+static struct silabs_tercab_config hauppauge_si2177_config = {
+	.tuner_address           = 0xC0 >> 1,      /* address of the tuner for ATSC/DVB-T */
+	.qam_if_khz              = HVR19x5_QAM_IF, /* needs to match demods qam if */
+	.vsb_if_khz              = HVR19x5_VSB_IF, /* needs to match demods vsb if */
+	.tuner_clock_control     = 2, /*0-always off 1-always on 2-clock managed */
+	.tuner_agc_control       = 1,
+	.fef_mode                = 0, /*0-slow normal AGC, 1-freeze pin, 2-slow initial AGC*/
+	.crystal_trim_xo_cap     = 8,
+	.indirect_i2c_connection = 1, /* Si2177 connected directly */
+};
+
+static int pvr2_si2177_attach(struct pvr2_dvb_adapter *adap)
+{
+	pr_info("%s()\n", __func__);
+
+	dvb_attach(silabs_tercab_attach, adap->fe,
+		   &adap->channel.hdw->i2c_adap,
+		   &hauppauge_si2177_config);
+
+	return 0;
+}
+
+/*------------------------------------------------------------------------*/
+/* Hauppauge PVR-USB2 Model 160000 */
+
+static struct silg_config pvr2_hvr1975_silg_config = {
+	/* Si2168B demodulator configuration */
+	.si_demod_enable         = !0,
+	.si_i2c_addr             = 0xC8 >> 1,
+	.min_delay_ms            = 85,
+	.ts_bus_mode             = 2, /*1-serial, 2-parallel.*/
+	.ts_clock_mode           = 2, /*0-auto_fixed, 1-auto_adapt, 2-manual.*/
+	.clk_gapped_en           = 1, /*0-disabled, 1-enabled.*/
+	.ts_par_clk_invert       = 0, /*0-not-invert, 1-invert*/
+	.ts_par_clk_shift        = 3, /*DVB-C QAM256 fix*/
+	.fef_mode                = 0, /* needs to match tuner */
+	.fef_pin                 = 3,
+	.fef_level               = 0,
+	.indirect_i2c_connection = 1, /*Si2177 connected directly*/
+	.start_ctrl              = NULL,
+
+	/* LG3306A demodulator configuration */
+	.lg_demod_enable         = !0,
+	.lg_i2c_addr             = 0xB2 >> 1,
+	.mpeg_mode               = LGDT3306A_MPEG_PARALLEL,
+	.tpclk_edge              = LGDT3306A_TPCLK_FALLING_EDGE,
+	.tpvalid_polarity        = LGDT3306A_TP_VALID_LOW,
+	.deny_i2c_rptr           = 1,
+	.spectral_inversion      = 1,
+	.qam_if_khz              = HVR19x5_QAM_IF, /* needs to match tuner */
+	.vsb_if_khz              = HVR19x5_VSB_IF, /* needs to match tuner */
+	.xtalMHz                 = 25,
+};
+
+static int pvr2_silg_attach(struct pvr2_dvb_adapter *adap)
+{
+	pr_info("%s()\n", __func__);
+
+	adap->fe = dvb_attach(silg_attach,
+				  &pvr2_hvr1975_silg_config,
+			      &adap->channel.hdw->i2c_adap);
+	if (adap->fe) {
+		pr_info("%s(): attached silg\n", __func__);
+		return 0;
+	}
+
+	return -EIO;
+}
+
+static const struct pvr2_dvb_props pvr2_160000_dvb_props = {
+	.frontend_attach = pvr2_silg_attach,
+	.tuner_attach    = pvr2_si2177_attach,
+};
+
+static const struct pvr2_device_client_desc pvr2_cli_160000[] = {
+	{ .module_id = PVR2_CLIENT_ID_CX25840 },
+	{ .module_id = PVR2_CLIENT_ID_TUNER,
+	  .i2c_address_list = "\x60" },
+	{ .module_id = PVR2_CLIENT_ID_DEMOD,
+	  .i2c_address_list = "\x59" },	//LG3306a addr
+};
+
+/*------------------------------------------------------------------------*/
+/* Hauppauge PVR-USB2 Model 160111 */
+
+static struct lgdt3306a_config pvr2_lgdt3306a_config = {
+	/* LG3306A demodulator configuration */
+	.i2c_addr           = 0xB2 >> 1,
+
+	/* user defined IF frequency in KHz */
+	.qam_if_khz         = HVR19x5_QAM_IF, //FGR - BUGBUG - needs to match tuner
+	.vsb_if_khz         = HVR19x5_VSB_IF, //FGR - BUGBUG - needs to match tuner
+
+	/* disable i2c repeater - 0:repeater enabled 1:repeater disabled */
+	.deny_i2c_rptr      = 1,
+
+	/* spectral inversion - 0:disabled 1:enabled */
+	.spectral_inversion = 1,
+
+	.mpeg_mode          = LGDT3306A_MPEG_PARALLEL,
+	.tpclk_edge         = LGDT3306A_TPCLK_FALLING_EDGE,
+	.tpvalid_polarity   = LGDT3306A_TP_VALID_LOW,
+
+	.xtalMHz            = 25, //demod clock freq in MHz; 24 or 25 supported
+};
+
+static int pvr2_lgdt3306a_attach(struct pvr2_dvb_adapter *adap)
+{
+	adap->fe = dvb_attach(lgdt3306a_attach, &pvr2_lgdt3306a_config,
+			      &adap->channel.hdw->i2c_adap);
+	if (adap->fe)
+		return 0;
+
+	return -EIO;
+}
+
+static const struct pvr2_dvb_props pvr2_160111_dvb_props = {
+	.frontend_attach = pvr2_lgdt3306a_attach,
+	.tuner_attach    = pvr2_si2177_attach,
+};
+
+static const struct pvr2_device_client_desc pvr2_cli_160111[] = {
+	{ .module_id = PVR2_CLIENT_ID_CX25840 },
+	{ .module_id = PVR2_CLIENT_ID_TUNER,
+	  .i2c_address_list = "\x60" },
+	{ .module_id = PVR2_CLIENT_ID_DEMOD,
+	  .i2c_address_list = "\x59" },	//LG3306a addr
+};
+#endif
+
 #define PVR2_FIRMWARE_75xxx "v4l-pvrusb2-73xxx-01.fw"
 static const char *pvr2_fw1_names_75xxx[] = {
 		PVR2_FIRMWARE_75xxx,
@@ -525,7 +665,58 @@ static const struct pvr2_device_desc pvr
 #endif
 };
 
+#define PVR2_FIRMWARE_160xxx "v4l-pvrusb2-160xxx-01.fw"
+static const char *pvr2_fw1_names_160xxx[] = {
+		PVR2_FIRMWARE_160xxx,
+};
 
+static const struct pvr2_device_desc pvr2_device_160000 = {
+		.description = "WinTV HVR-1975 Model 160000",
+		.shortname = "160000",
+		.client_table.lst = pvr2_cli_160000,
+		.client_table.cnt = ARRAY_SIZE(pvr2_cli_160000),
+		.fx2_firmware.lst = pvr2_fw1_names_160xxx,
+		.fx2_firmware.cnt = ARRAY_SIZE(pvr2_fw1_names_160xxx),
+		.default_tuner_type = TUNER_SILABS_TERCAB,
+		.flag_has_cx25840 = !0,
+		.flag_has_hauppauge_rom = !0,
+		.flag_has_analogtuner = !0,
+		.flag_has_composite = !0,
+		.flag_has_svideo = !0,
+		.flag_fx2_16kb = !0,
+		.signal_routing_scheme = PVR2_ROUTING_SCHEME_HAUPPAUGE,
+		.digital_control_scheme = PVR2_DIGITAL_SCHEME_HAUPPAUGE,
+		.default_std_mask = V4L2_STD_NTSC_M,
+		.led_scheme = PVR2_LED_SCHEME_HAUPPAUGE,
+		.ir_scheme = PVR2_IR_SCHEME_ZILOG,
+#ifdef CONFIG_VIDEO_PVRUSB2_DVB
+		.dvb_props = &pvr2_160000_dvb_props,
+#endif
+};
+
+static const struct pvr2_device_desc pvr2_device_160111 = {
+		.description = "WinTV HVR-1955 Model 160111",
+		.shortname = "160111",
+		.client_table.lst = pvr2_cli_160111,
+		.client_table.cnt = ARRAY_SIZE(pvr2_cli_160111),
+		.fx2_firmware.lst = pvr2_fw1_names_160xxx,
+		.fx2_firmware.cnt = ARRAY_SIZE(pvr2_fw1_names_160xxx),
+		.default_tuner_type = TUNER_SILABS_TERCAB,
+		.flag_has_cx25840 = !0,
+		.flag_has_hauppauge_rom = !0,
+		.flag_has_analogtuner = !0,
+		.flag_has_composite = !0,
+		.flag_has_svideo = !0,
+		.flag_fx2_16kb = !0,
+		.signal_routing_scheme = PVR2_ROUTING_SCHEME_HAUPPAUGE,
+		.digital_control_scheme = PVR2_DIGITAL_SCHEME_HAUPPAUGE,
+		.default_std_mask = V4L2_STD_NTSC_M,
+		.led_scheme = PVR2_LED_SCHEME_HAUPPAUGE,
+		.ir_scheme = PVR2_IR_SCHEME_ZILOG,
+#ifdef CONFIG_VIDEO_PVRUSB2_DVB
+		.dvb_props = &pvr2_160111_dvb_props,
+#endif
+};
 
 /*------------------------------------------------------------------------*/
 
@@ -552,6 +743,10 @@ struct usb_device_id pvr2_device_table[]
 	  .driver_info = (kernel_ulong_t)&pvr2_device_751xx},
 	{ USB_DEVICE(0x0ccd, 0x0039),
 	  .driver_info = (kernel_ulong_t)&pvr2_device_av400},
+	{ USB_DEVICE(0x2040, 0x7502), /* HVR-1955 */
+	  .driver_info = (kernel_ulong_t)&pvr2_device_160111},
+	{ USB_DEVICE(0x2040, 0x7510), /* HVR-1975 */
+	  .driver_info = (kernel_ulong_t)&pvr2_device_160000},
 	{ }
 };
 
@@ -560,3 +755,4 @@ MODULE_FIRMWARE(PVR2_FIRMWARE_29xxx);
 MODULE_FIRMWARE(PVR2_FIRMWARE_24xxx);
 MODULE_FIRMWARE(PVR2_FIRMWARE_73xxx);
 MODULE_FIRMWARE(PVR2_FIRMWARE_75xxx);
+MODULE_FIRMWARE(PVR2_FIRMWARE_160xxx);
--- linux-4.11/drivers/media/usb/pvrusb2/pvrusb2-devattr.h.0140~	2017-05-01 04:47:48.000000000 +0200
+++ linux-4.11/drivers/media/usb/pvrusb2/pvrusb2-devattr.h	2017-06-30 13:33:26.636749934 +0200
@@ -66,6 +66,7 @@ struct pvr2_string_table {
 #define PVR2_ROUTING_SCHEME_GOTVIEW 1
 #define PVR2_ROUTING_SCHEME_ONAIR 2
 #define PVR2_ROUTING_SCHEME_AV400 3
+#define PVR2_ROUTING_SCHEME_HAUP160XXX 4
 
 #define PVR2_DIGITAL_SCHEME_NONE 0
 #define PVR2_DIGITAL_SCHEME_HAUPPAUGE 1
--- linux-4.11/drivers/media/usb/pvrusb2/pvrusb2-dvb.c.0140~	2017-05-01 04:47:48.000000000 +0200
+++ linux-4.11/drivers/media/usb/pvrusb2/pvrusb2-dvb.c	2017-06-30 13:33:26.637749910 +0200
@@ -244,6 +244,13 @@ static int pvr2_dvb_stop_feed(struct dvb
 static int pvr2_dvb_bus_ctrl(struct dvb_frontend *fe, int acquire)
 {
 	struct pvr2_dvb_adapter *adap = fe->dvb->priv;
+	const struct pvr2_hdw *hdw = adap->channel.hdw;
+
+	pvr2_trace(PVR2_TRACE_DVB_FEED, "%s(): dvb bus ctrl: %d", __func__, acquire);
+
+	if (hdw->fe_ts_bus_ctrl)
+		hdw->fe_ts_bus_ctrl(fe, acquire);
+
 	return pvr2_channel_limit_inputs(
 	    &adap->channel,
 	    (acquire ? (1 << PVR2_CVAL_INPUT_DTV) : 0));
@@ -361,8 +368,10 @@ static int pvr2_dvb_frontend_init(struct
 			adap->fe->ops.analog_ops.standby(adap->fe);
 
 		/* Ensure all frontends negotiate bus access */
+		/* save the original function pointer */
+		hdw->fe_ts_bus_ctrl = adap->fe->ops.ts_bus_ctrl;
+		pvr2_trace(PVR2_TRACE_INFO, "transferring ts_bus_ctrl() to pvr2_dvb_bus_ctrl()");
 		adap->fe->ops.ts_bus_ctrl = pvr2_dvb_bus_ctrl;
-
 	} else {
 		pvr2_trace(PVR2_TRACE_ERROR_LEGS,
 			   "no frontend was attached!");
--- linux-4.11/drivers/media/usb/pvrusb2/pvrusb2-fx2-cmd.h.0140~	2017-05-01 04:47:48.000000000 +0200
+++ linux-4.11/drivers/media/usb/pvrusb2/pvrusb2-fx2-cmd.h	2017-06-30 13:33:26.637749910 +0200
@@ -38,6 +38,10 @@
 
 #define FX2CMD_FWPOST1          0x52u
 
+/* These 2 only exist on Model 160xxx */
+#define FX2CMD_HCW_DEMOD_RESET_PIN 0xd4u
+#define FX2CMD_HCW_MAKO_SLEEP_PIN  0xd5u
+
 #define FX2CMD_POWER_OFF        0xdcu
 #define FX2CMD_POWER_ON         0xdeu
 
--- linux-4.11/drivers/media/usb/pvrusb2/pvrusb2-hdw.c.0140~	2017-05-01 04:47:48.000000000 +0200
+++ linux-4.11/drivers/media/usb/pvrusb2/pvrusb2-hdw.c	2017-06-30 13:33:26.637749910 +0200
@@ -316,6 +316,8 @@ static const struct pvr2_fx2cmd_descdef
 	{FX2CMD_ONAIR_DTV_STREAMING_OFF, "onair dtv stream off"},
 	{FX2CMD_ONAIR_DTV_POWER_ON, "onair dtv power on"},
 	{FX2CMD_ONAIR_DTV_POWER_OFF, "onair dtv power off"},
+	{FX2CMD_HCW_DEMOD_RESET_PIN, "hcw demod reset pin"},
+	{FX2CMD_HCW_MAKO_SLEEP_PIN, "hcw mako sleep pin"},
 };
 
 
@@ -2093,6 +2095,7 @@ static void pvr2_hdw_setup_low(struct pv
 	unsigned int idx;
 	struct pvr2_ctrl *cptr;
 	int reloadFl = 0;
+
 	if (hdw->hdw_desc->fx2_firmware.cnt) {
 		if (!reloadFl) {
 			reloadFl =
@@ -2141,6 +2144,23 @@ static void pvr2_hdw_setup_low(struct pv
 	pvr2_i2c_core_init(hdw);
 	if (!pvr2_hdw_dev_ok(hdw)) return;
 
+	/* reset demod only on Hauppauge 160xxx platform */
+	if (hdw->usb_dev->descriptor.idVendor == 0x2040 &&
+			(hdw->usb_dev->descriptor.idProduct == 0x7502 || hdw->usb_dev->descriptor.idProduct == 0x7510)) {
+		pr_info("%s(): resetting 160xxx demod\n", __func__);
+		//FGR - not sure this is the proper place to reset demods once only
+		pvr2_issue_simple_cmd(hdw,
+				     FX2CMD_HCW_DEMOD_RESET_PIN |
+				     (1 << 8) |
+				     ((0) << 16));
+		msleep(10);
+		pvr2_issue_simple_cmd(hdw,
+				     FX2CMD_HCW_DEMOD_RESET_PIN |
+				     (1 << 8) |
+				     ((1) << 16));
+		msleep(10);
+	}
+
 	pvr2_hdw_load_modules(hdw);
 	if (!pvr2_hdw_dev_ok(hdw)) return;
 
@@ -2205,7 +2225,6 @@ static void pvr2_hdw_setup_low(struct pv
 			   hdw->tuner_type);
 	}
 
-
 	if (!pvr2_hdw_dev_ok(hdw)) return;
 
 	if (hdw->hdw_desc->signal_routing_scheme ==
@@ -3990,6 +4009,17 @@ int pvr2_hdw_cmd_decoder_reset(struct pv
 static int pvr2_hdw_cmd_hcw_demod_reset(struct pvr2_hdw *hdw, int onoff)
 {
 	hdw->flag_ok = !0;
+
+	//BUGBUG - use this for 160xxx, but how can we tell it's the right HW
+	if (hdw->usb_dev->descriptor.idVendor == 0x2040 &&
+			(hdw->usb_dev->descriptor.idProduct == 0x7502 || hdw->usb_dev->descriptor.idProduct == 0x7510)) {
+		pr_info("%s(): resetting demod on Hauppauge 160xxx platform skipped\n", __func__);
+		//FGR don't want Demod reset on 160xxx or it will trash Demod tristate
+		return pvr2_issue_simple_cmd(hdw,
+				     FX2CMD_HCW_MAKO_SLEEP_PIN |
+				     (1 << 8) |
+				     ((onoff ? 1 : 0) << 16));
+	}
 	return pvr2_issue_simple_cmd(hdw,
 				     FX2CMD_HCW_DEMOD_RESETIN |
 				     (1 << 8) |
--- linux-4.11/drivers/media/usb/pvrusb2/pvrusb2-hdw-internal.h.0140~	2017-05-01 04:47:48.000000000 +0200
+++ linux-4.11/drivers/media/usb/pvrusb2/pvrusb2-hdw-internal.h	2017-06-30 13:33:26.637749910 +0200
@@ -381,6 +381,9 @@ struct pvr2_hdw {
 
 	struct pvr2_ctrl *controls;
 	unsigned int control_cnt;
+
+	/* experimental... */
+	int (*fe_ts_bus_ctrl) (struct dvb_frontend*, int);
 };
 
 /* This function gets the current frequency */
--- linux-4.11/drivers/media/v4l2-core/tuner-core.c.0140~	2017-05-01 04:47:48.000000000 +0200
+++ linux-4.11/drivers/media/v4l2-core/tuner-core.c	2017-06-30 13:33:26.637749910 +0200
@@ -40,6 +40,7 @@
 #include "xc5000.h"
 #include "tda18271.h"
 #include "xc4000.h"
+#include "silabs_tercab.h"
 
 #define UNSET (-1U)
 
@@ -398,6 +399,30 @@ static void set_type(struct i2c_client *
 		tune_now = 0;
 		break;
 	}
+	case TUNER_SILABS_TERCAB:
+	{
+		static struct silabs_tercab_config silabs_config = {
+			.tuner_address           = 0xC0 >> 1,      /* address of the tuner for ATSC/DVB-T */
+			.qam_if_khz              = HVR19x5_QAM_IF, /* needs to match demods qam if */
+			.vsb_if_khz              = HVR19x5_VSB_IF, /* needs to match demods vsb if */
+			.tuner_clock_control     = 1, /* 0:always off 1:always on 2:clock managed */
+			.tuner_agc_control       = 1,
+			.fef_mode                = 0, /* fef mode slow normal agc */
+			.crystal_trim_xo_cap     = 8,
+			.indirect_i2c_connection = 1, /* tuner connected directly(?) */
+		};
+
+		printk(KERN_INFO "%s: looking for Silicon Labs tuner on i2c bus: %d\n",
+		       __func__, i2c_adapter_id(t->i2c->adapter));
+
+		if (!dvb_attach(silabs_tercab_attach, &t->fe, t->i2c->adapter, &silabs_config)) {
+			printk(KERN_ERR "%s: attaching Silicon Labs tuner failed\n", __func__);
+			goto attach_failed;
+		}
+		printk(KERN_INFO "%s: Silicon Labs tuner attached\n", __func__);
+		tune_now = 0;
+		break;
+	}
 	default:
 		if (!dvb_attach(simple_tuner_attach, &t->fe,
 				t->i2c->adapter, t->i2c->addr, t->type))
@@ -645,17 +670,27 @@ static int tuner_probe(struct i2c_client
 			}
 			break;
 		case 0x60:
-			if (tuner_symbol_probe(tea5767_autodetection,
+			if (tuner_symbol_probe(silabs_tercab_autodetection,
 					       t->i2c->adapter, t->i2c->addr)
-					>= 0) {
-				t->type = TUNER_TEA5767;
-				t->mode_mask = T_RADIO;
-				/* Sets freq to FM range */
-				tuner_lookup(t->i2c->adapter, &radio, &tv);
-				if (tv)
-					tv->mode_mask &= ~T_RADIO;
-
+					== 0) {
+				dprintk("Silicon Labs tuner @ 0x%02X detected\n", t->i2c->addr);
+				t->type = TUNER_SILABS_TERCAB;
+				t->mode_mask = T_ANALOG_TV;
 				goto register_client;
+			} else {
+				dprintk("i2c addr 0x60: tea5767_autodetection\n");
+				if (tuner_symbol_probe(tea5767_autodetection,
+					       	   t->i2c->adapter, t->i2c->addr)
+						>= 0) {
+					t->type = TUNER_TEA5767;
+					t->mode_mask = T_RADIO;
+					/* Sets freq to FM range */
+					tuner_lookup(t->i2c->adapter, &radio, &tv);
+					if (tv)
+						tv->mode_mask &= ~T_RADIO;
+
+					goto register_client;
+				}
 			}
 			break;
 		}
--- linux-4.11/include/media/tuner.h.0140~	2017-05-01 04:47:48.000000000 +0200
+++ linux-4.11/include/media/tuner.h	2017-06-30 13:33:26.637749910 +0200
@@ -142,6 +142,8 @@
 #define TUNER_SONY_BTF_PK467Z		90	/* NTSC_JP */
 #define TUNER_SONY_BTF_PB463Z		91	/* NTSC */
 
+#define TUNER_SILABS_TERCAB		92	/* Silicon Labs terrestrial/cable tuner series */
+
 /* tv card specific */
 #define TDA9887_PRESENT			(1<<0)
 #define TDA9887_PORT1_INACTIVE		(1<<1)
--- linux-4.11/drivers/media/tuners/Makefile.omv~	2017-07-02 23:42:29.309109663 +0200
+++ linux-4.11/drivers/media/tuners/Makefile	2017-07-02 23:43:25.462612146 +0200
@@ -41,6 +41,7 @@ obj-$(CONFIG_MEDIA_TUNER_R820T) += r820t
 obj-$(CONFIG_MEDIA_TUNER_MXL301RF) += mxl301rf.o
 obj-$(CONFIG_MEDIA_TUNER_QM1D1C0042) += qm1d1c0042.o
 obj-$(CONFIG_MEDIA_TUNER_M88RS6000T) += m88rs6000t.o
+obj-$(CONFIG_MEDIA_TUNER_SILABS_TERCAB) += silabs_tercab.o
 
 ccflags-y += -I$(srctree)/drivers/media/dvb-core
 ccflags-y += -I$(srctree)/drivers/media/dvb-frontends
